// JVSDKDEMODlg.cpp : implementation file
//

#include "stdafx.h"
#include "JVSDKDEMO.h"
#include "JVSDKDEMODlg.h"
#include "JVSDK.h"
#pragma comment(lib,"JVSDK.lib")
#include "config.h"
#include "full.h"
#include "JvsSock.h"
extern "C"
{
#include "Jmp4pkg.h"
#pragma comment(lib, "Jmp4pkg.lib")
}
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define JVS_MAX_DATA_SIZE	1024*400
//ݸSDK֪ͨ¼SDKҪӦó֪ͨʱʹô¼֪ͨͲμJVSDK.h
#define WM_SDK_NOTIFY		WM_USER + 0x600

CONFIG g_config;

char	acAppPath[MAX_PATH]; //·

void FuncEncDataCallback(int nChannel, PUCHAR pData, UINT nBuffLen, int nFrameType, BOOL bMov);
void FuncEncDataCallbacknet(int nChannel, PUCHAR pData, UINT nBuffLen, int nFrameType, BOOL bMov);

void FuncRawDataCallback(int nChannel, PUCHAR pRawBuffer, DWORD dwVideo,DWORD dwHD1);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJVSDKDEMODlg dialog

CJVSDKDEMODlg::CJVSDKDEMODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CJVSDKDEMODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CJVSDKDEMODlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	memset(&g_config, 0, sizeof(CONFIG));
	m_nCurSel = 0;
	m_bInit	=	FALSE;
	m_pSocket = NULL;
}

void CJVSDKDEMODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJVSDKDEMODlg)
	DDX_Control(pDX, IDC_COMBO_CHANNELMODE, m_comboChannelMode);
	DDX_Control(pDX, IDC_CHECK_CIF, m_chkCIF);
	DDX_Control(pDX, IDC_CHECK_SUB_STREAM, m_chkSubStream);
	DDX_Control(pDX, IDC_CHECK_NTSC, m_chkNTSC);
	DDX_Control(pDX, IDC_CHECK_WD1MODE, m_chkWD1MODE);
	DDX_Control(pDX, IDC_COMBO_MODE, m_comboMode);
	DDX_Control(pDX, IDC_LIST_INFO, m_lstInfo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CJVSDKDEMODlg, CDialog)
	//{{AFX_MSG_MAP(CJVSDKDEMODlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, OnButtonClose)
	ON_BN_CLICKED(IDC_BUTTON_OPEN_PREVIEW, OnButtonOpenPreview)
	ON_BN_CLICKED(IDC_BUTTON_STOP_PREVIEW, OnButtonStopPreview)
	ON_BN_CLICKED(IDC_BUTTON_START_COMPRESS, OnButtonStartCompress)
	ON_BN_CLICKED(IDC_BUTTON_STOP_COMPRESS, OnButtonStopCompress)
	ON_BN_CLICKED(IDC_BUTTON_WRITE, OnButtonWrite)
	ON_BN_CLICKED(IDC_BUTTON_STOP_WRITE, OnButtonStopWrite)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE_OSD, OnButtonEnableOsd)
	ON_BN_CLICKED(IDC_BUTTON_DISABLE_OSD, OnButtonDisableOsd)
	ON_BN_CLICKED(IDC_BUTTON_QP, OnButtonQp)
	ON_BN_CLICKED(IDC_BUTTON_FULL_SCREEN, OnButtonFullScreen)
	ON_WM_MOVE()
	ON_BN_CLICKED(IDC_BUTTON_BITMAP, OnButtonBitmap)
	ON_BN_CLICKED(IDC_BUTTON_NETWORK, OnButtonNetwork)
	ON_BN_CLICKED(IDC_CHECK_MOV_DETECT, OnCheckMovDetect)
	ON_BN_CLICKED(IDC_CHECK_AUDIO_PREVIEW, OnCheckAudioPreview)
	ON_BN_CLICKED(IDC_CHECK_AUDIO_COMPRESS, OnCheckAudioCompress)
	ON_BN_CLICKED(IDC_BUTTON_SET_MODE, OnButtonSetMode)
	ON_BN_CLICKED(IDC_BUTTON_CAP_FILE, OnButtonCapFile)
	ON_BN_CLICKED(IDC_BUTTON_RAW_DATA, OnButtonRawData)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_SDK_NOTIFY, OnSDKNotify)
	ON_MESSAGE(WM_DEVICECHANGE, OnDeviceChange)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJVSDKDEMODlg message handlers

BOOL CJVSDKDEMODlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CHAR	acPath[MAX_PATH];
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	m_chkWD1MODE.SetCheck(TRUE);
	m_comboMode.SetCurSel(1);
	m_comboChannelMode.SetCurSel(0);
	// TODO: Add extra initialization here
	//ʼSDK
	CString s;
	JVS_InitSDK(GetSafeHwnd(), WM_SDK_NOTIFY);

	g_config.nTotalChannel = 0;

	//ڴͨǰʼSDKԴ
	//ʼԤԴ
	if (JVS_InitPreview() == TRUE)
	{
		g_config.bInitPreview = TRUE;
		m_lstInfo.AddString("The Preview initialization is success!");
	}
	else
	{
		g_config.bInitPreview = FALSE;
		m_lstInfo.AddString("The Preview initialization is success failed!");
	}
	//ʼѹԴ
	JVS_InitCompress();

	//עص
	JVS_SetCallBack(FuncEncDataCallback,FuncEncDataCallbacknet, NULL);

	GetModuleFileName(NULL, acAppPath, MAX_PATH);//ȫ·
	size_t n = _tcslen(acAppPath);
	while (n>0)
	{
		n--;
		if (acAppPath[n] == _T('\\'))
		{
			acAppPath[n] = 0;
			break;
		}
	}
	//ƵźʱͼƬ
	char buffer[MAX_PATH];
	sprintf(acPath, "%s\\NoVideo.bmp", acAppPath);
	sprintf(buffer, "%s\\NoDevice.bmp", acAppPath);
	JVS_SetNoSignalFile(acPath, buffer);

	g_config.Channel[0].pkgHandle                =   NULL;

	g_config.Channel[0].compression.dCompressType = 0;//D1ѹ
	g_config.Channel[0].compression.ulStreamType  = 1;//Ƶ
	g_config.Channel[0].compression.dQualitiMode  = 0;//baselineѹ
	g_config.Channel[0].compression.dCompressPreset = 1;
	g_config.Channel[0].compression.dRate           =  600; //
	g_config.Channel[0].compression.dFrameRate      =  0;   //025֡ 112.5֡ 26.25֡

	g_config.Channel[0].compression.bCompressnet = FALSE; //ڶ
	g_config.Channel[0].compression.dCompressTypenet = 1;//D1ѹ
	g_config.Channel[0].compression.ulStreamTypenet  = 1;//Ƶ
	g_config.Channel[0].compression.dQualitiModenet  = 0;//baselineѹ
	g_config.Channel[0].compression.dCompressPresetnet = 1;
	g_config.Channel[0].compression.dRatenet           =  150; //
	g_config.Channel[0].compression.dFrameRatenet      =  1;   //025֡ 112.5֡ 26.25֡

	//ѹ
	JVS_SetQualityMode(0, g_config.Channel[0].compression.dCompressType,
						  g_config.Channel[0].compression.dQualitiMode,
						  g_config.Channel[0].compression.dCompressPreset, 
						  g_config.Channel[0].compression.dRate ,
						  g_config.Channel[0].compression.dFrameRate);

	JVS_SetQualityModeNet(0, g_config.Channel[0].compression.bCompressnet,
						     g_config.Channel[0].compression.dCompressTypenet,
						     g_config.Channel[0].compression.dQualitiModenet,
						     g_config.Channel[0].compression.dCompressPresetnet, 
						     g_config.Channel[0].compression.dRatenet,
						     g_config.Channel[0].compression.dFrameRatenet);

	SetDlgItemInt(IDC_EDIT_QP, 600);
	SetDlgItemInt(IDC_EDIT_MOV_GRADE, 15);
	SetDlgItemInt(IDC_EDIT_MOV_THRESHOLD, 15);

	g_config.Channel[0].fAnalyse = NULL;


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CJVSDKDEMODlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CJVSDKDEMODlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CJVSDKDEMODlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CJVSDKDEMODlg::OnButtonOpen() 
{
	// TODO: Add your control notification handler code here

	if (!g_config.Channel[0].bOpened)
	{
		g_config.Channel[0].bOpened = JVS_OpenChannel(0);
		UpdateDevices();

		if (g_config.Channel[0].bOpened)
		{
			m_lstInfo.AddString("Open Channel 0");
			switch(m_comboChannelMode.GetCurSel())
			{
			case 0:
				JVS_SetChipMode(TRUE, TRUE, TRUE, TRUE, TRUE);
				break;

			case 1:
				JVS_SetChipMode(FALSE, TRUE, TRUE, TRUE, TRUE);
				break;

			case 2:
				JVS_SetChipMode(FALSE, FALSE, FALSE, FALSE, FALSE);
				break;
			}
			
			g_config.Channel[0].dwPixelMode = m_comboMode.GetCurSel();
			JVS_SetVideoPixelMode(0, m_comboMode.GetCurSel(), ((CButton *)GetDlgItem(IDC_CHECK_NTSC))->GetCheck(),m_chkWD1MODE.GetCheck());
		}
	}
}

void CJVSDKDEMODlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	if (g_config.bInitPreview)
	{
		JVS_ReleasePreview();
		g_config.bInitPreview = FALSE;
	}
	JVS_ReleaseCompress();

	if (g_config.Channel[0].bOpened)
	{
		JVS_CloseChannel(0);
		g_config.Channel[0].bOpened = FALSE;
	}

	if (g_config.Channel[0].fout)
	{
		fclose(g_config.Channel[0].fout);
		g_config.Channel[0].fout = NULL;
	}

	//رsocket
	if (m_pSocket)
	{
		g_config.Channel[0].bTransmitting = FALSE;
		g_config.Channel[0].hSocket = NULL;
		CJvsSock * pSocket = (CJvsSock *)m_pSocket;
		pSocket->SendCloseSignal();
		pSocket->Close();
		delete pSocket;
		m_pSocket = NULL;
	}

	if (g_config.Channel[0].fAnalyse)
	{
		fclose(g_config.Channel[0].fAnalyse);
		g_config.Channel[0].fAnalyse	= NULL;
	}

	//ͷSDK
	JVS_ReleaseSDK();
}

void CJVSDKDEMODlg::OnOK() 
{
	// TODO: Add extra validation here
	
//	CDialog::OnOK();
}

void CJVSDKDEMODlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	DestroyWindow();
}

void CJVSDKDEMODlg::OnButtonClose() 
{
	// TODO: Add your control notification handler code here
	if (g_config.Channel[0].bOpened)
	{
		JVS_CloseChannel(0);
		g_config.Channel[0].bOpened = FALSE;
		g_config.Channel[0].bVideoPreview = FALSE;

		m_lstInfo.AddString("Close Channel 0");
	}
	
}

void CJVSDKDEMODlg::OnButtonOpenPreview() 
{
	// TODO: Add your control notification handler code here
	if (g_config.Channel[0].bOpened)
	{
		RECT rt;
		if (g_config.bInitPreview)
		{
			this->GetWindowRect(&rt);
			rt.left += 13;
			rt.right = rt.left + 352;//352;
			rt.top += 32;
			rt.bottom = rt.top + 288;//288;
			JVS_SetVideoPreview(0, this->GetSafeHwnd(), &rt, TRUE);
			m_bInit	=	TRUE;
			g_config.Channel[0].bVideoPreview = TRUE;
			JVS_SetOSD(0, 1, (PUCHAR)"Channel 1", TRUE);
			m_lstInfo.AddString("Channel 0: Enable Preview");
		}
	}
}

void CJVSDKDEMODlg::OnButtonStopPreview() 
{
	// TODO: Add your control notification handler code here
	if (g_config.Channel[0].bOpened)
	{
		JVS_SetVideoPreview(0, this->GetSafeHwnd(), NULL, FALSE);
		g_config.Channel[0].bVideoPreview = FALSE;
		m_lstInfo.AddString("Channel 0:Disable Preview");
	}
	
}

void CJVSDKDEMODlg::OnButtonStartCompress() 
{
	// TODO: Add your control notification handler code here
	PCHANNEL pChannel = &g_config.Channel[0];

	if (pChannel->bOpened)
	{
		//֪ͨͻµͼС
		if (pChannel->bTransmitting)
		{
			//ڸͼСŷʹϢ
			((CJvsSock *)pChannel->hSocket)->SendFrameSize();
		}
		JVS_StartCompress(0);
		g_config.Channel[0].bCompress = TRUE;
		m_lstInfo.AddString("Channel 0: Enable Compress");

		//ݷãdemoʾһ
		if (pChannel->fAnalyse == NULL)
		{
			pChannel->fAnalyse = fopen("analyse.txt", "wt");
		}
	}
	
}

void CJVSDKDEMODlg::OnButtonStopCompress() 
{
	// TODO: Add your control notification handler code here
	if (g_config.Channel[0].bOpened)
	{
		g_config.Channel[0].bCompress = FALSE;
		JVS_StopCompress(0, TRUE);
		m_lstInfo.AddString("Channel 0: Disable Compress");
		if (g_config.Channel[0].fAnalyse)
		{
			fclose(g_config.Channel[0].fAnalyse);
			g_config.Channel[0].fAnalyse = NULL;
		}
	}
	
}


void CJVSDKDEMODlg::OnButtonWrite() 
{
	// TODO: Add your control notification handler code here
	char szmp4file[MAX_PATH];
	char szmp4fileIdx[MAX_PATH];
	CString strMnr;
	CString strIdx;

	if (g_config.Channel[0].bOpened == FALSE)
		return;
	strMnr.Format("%s\\test300.mp4", acAppPath);
	strIdx.Format("%s\\test300.jdx", acAppPath);

	sprintf(szmp4file,"%s",strMnr);
	sprintf(szmp4fileIdx,"%s",strIdx);
	JVS_GetHeaderData(0, &g_config.Channel[0].headerData);//ʹõڶʹJVS_GetHeaderDatanet
	JVS_GetHeaderMP4(0, &g_config.Channel[0].mp4headerData);//ʹõڶʹJVS_GetHeaderMP4net
	if (g_config.Channel[0].pkgHandle == NULL)
	{	
		
		PKG_VIDEO_PARAM	VideoParam;
		VideoParam.iFrameWidth  = g_config.Channel[0].headerData.dwFrameWidth;
		VideoParam.iFrameHeight = g_config.Channel[0].headerData.dwFrameHeight;
		VideoParam.avcC.iSpsSize		= g_config.Channel[0].mp4headerData.i_sps_size;
		VideoParam.avcC.iPpsSize		= g_config.Channel[0].mp4headerData.i_pps_size;
		VideoParam.avcC.pSps			= g_config.Channel[0].mp4headerData.p_sps;
		VideoParam.avcC.pPps			= g_config.Channel[0].mp4headerData.p_pps;
		
		VideoParam.fFrameRate	= 25.0f;//֡
				
		g_config.Channel[0].pkgHandle = JP_OpenPackage(&VideoParam, TRUE, ((CButton *)GetDlgItem(IDC_CHECK_AUDIO_COMPRESS))->GetCheck(), szmp4file,szmp4fileIdx);//Ƶ
		g_config.Channel[0].bWriteOK = TRUE;
		JVS_InsertKeyFrame(0);	//ļһؼ֡Ա
		m_lstInfo.SetCurSel(m_lstInfo.AddString("Create test300.mp4 successfully"));	
	}
}

void CJVSDKDEMODlg::OnButtonStopWrite() 
{
	// TODO: Add your control notification handler code here
	g_config.Channel[0].bWriteOK = FALSE;
	if (g_config.Channel[0].pkgHandle != NULL)
	{
		g_config.Channel[0].bWriteOK = FALSE;
		JP_ClosePackage(g_config.Channel[0].pkgHandle);
		g_config.Channel[0].pkgHandle = NULL;
	}


	m_lstInfo.SetCurSel(m_lstInfo.AddString("Close File"));
}

void CJVSDKDEMODlg::OnButtonEnableOsd() 
{
	// TODO: Add your control notification handler code here
	JVS_SetOSD(0, 1, (PUCHAR)"Channel 2", TRUE);
}

void CJVSDKDEMODlg::OnButtonDisableOsd() 
{
	// TODO: Add your control notification handler code here
	JVS_SetOSD(0, 1, NULL, FALSE);
}


void CJVSDKDEMODlg::OnButtonQp() 
{
	// TODO: Add your control notification handler code here
	g_config.Channel[0].compression.dRate = GetDlgItemInt(IDC_EDIT_QP);
    if (m_chkSubStream.GetCheck())
		g_config.Channel[0].compression.bCompressnet = TRUE;
	else
		g_config.Channel[0].compression.bCompressnet = FALSE;

	if (m_chkCIF.GetCheck())
		g_config.Channel[0].compression.dCompressType = 1;
	else
		g_config.Channel[0].compression.dCompressType = 0;

	//ѹ
	JVS_SetQualityMode(0, g_config.Channel[0].compression.dCompressType,
						  g_config.Channel[0].compression.dQualitiMode,
						  g_config.Channel[0].compression.dCompressPreset, 
						  g_config.Channel[0].compression.dRate ,
						  g_config.Channel[0].compression.dFrameRate);
	
	JVS_SetQualityModeNet(0, g_config.Channel[0].compression.bCompressnet,
		g_config.Channel[0].compression.dCompressTypenet,
		g_config.Channel[0].compression.dQualitiModenet,
		g_config.Channel[0].compression.dCompressPresetnet, 
		g_config.Channel[0].compression.dRatenet,
		g_config.Channel[0].compression.dFrameRatenet);

	CString s;
	s.Format("Compression quality:%d", g_config.Channel[0].compression.dRate);
	m_lstInfo.SetCurSel(m_lstInfo.AddString(s));
}

void CJVSDKDEMODlg::OnButtonFullScreen() 
{
	// TODO: Add your control notification handler code here
	JVS_SetVideoPreview(0, this->GetSafeHwnd(), NULL, FALSE);
	CFull cd;
	cd.DoModal();
	if (g_config.bInitPreview)
	{
		RECT rt;
		this->GetWindowRect(&rt);
		rt.left += 13;
		rt.right = rt.left + 352;
		rt.top += 32;
		rt.bottom = rt.top + 288;
		JVS_SetVideoPreview(0, this->GetSafeHwnd(), &rt, TRUE);
	}
}

//SDKʹõĴѹݵĻص
void FuncEncDataCallback(int nChannel, PUCHAR pData, UINT nBuffLen, int nFrameType, BOOL bMov)
{
	//Ƿյƶź
	if (bMov)
	{
		Beep(1000, 1);
	}
	PCHANNEL pChannel = &g_config.Channel[0];
	//ļ洢
	if (pChannel->bWriteOK && pChannel->pkgHandle)
	{					
		AV_PACKET			avPkt;			
		avPkt.pData = pData;
		avPkt.iSize = nBuffLen;			
		if (nFrameType != JVE_TYPE_AUD)
		{
			avPkt.iType = JVS_PKG_VIDEO;
		}
		else
		{
			avPkt.iType = JVS_PKG_AUDIO;
		}						
		JP_PackageOneFrame(pChannel->pkgHandle, &avPkt);
	}

	//
	if (pChannel->bTransmitting)
	{
		((CJvsSock *)pChannel->hSocket)->SendFrameData(pData, nBuffLen, nFrameType);
	}

	//ݷãdemoʾ
	if (pChannel->fAnalyse)
	{
		if (nFrameType == JVS_TYPE_IDR)
			fwrite("Key Frame", 1, 8, pChannel->fAnalyse);
		char acBuff[128];
		_itoa( nBuffLen, acBuff, 10 );
		fwrite(acBuff, 1, strlen(acBuff), pChannel->fAnalyse);
		if (nFrameType == JVS_TYPE_SKIP)
		{
			sprintf(acBuff, "(SKIP):%x-%x,%x,%x,%x", *(int *)&pData[4], pData[8], pData[9], pData[10], pData[11]);
			fwrite(acBuff, 1, strlen(acBuff), pChannel->fAnalyse);
		}
		fwrite("\n", 1, 1, pChannel->fAnalyse);
	}
}
void FuncEncDataCallbacknet(int nChannel, PUCHAR pData, UINT nBuffLen, int nFrameType, BOOL bMov)
{
  //ڶݴɲյһ
  //ڶһ紫䣬ɽڶʽͣ֡ʽЧ
}
void CJVSDKDEMODlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);
	
	// TODO: Add your message handler code here
	if (m_bInit)
	{
		RECT rt;
		GetWindowRect(&rt);
		rt.left += 13;
		rt.right = rt.left + 352;
		rt.top += 32;
		rt.bottom = rt.top + 288;
		if (g_config.Channel[0].bVideoPreview == TRUE)
			JVS_SetVideoPreview(0, GetSafeHwnd(), &rt, TRUE);
	}
	
}

void CJVSDKDEMODlg::OnButtonBitmap() 
{
	// TODO: Add your control notification handler code here
	if (g_config.Channel[0].bOpened == FALSE)
		return;

	//ӦóԼ֤СССSDK
	if (g_config.Channel[0].Bitmap.pRGB != NULL)
	{
		return;	//Ѿ˵һץͼûн
	}

	JVS_GetBitmapSize(0, &g_config.Channel[0].Bitmap.dwWidth,&g_config.Channel[0].Bitmap.dwHeight);

	g_config.Channel[0].Bitmap.pRGB = new UCHAR[g_config.Channel[0].Bitmap.dwWidth * g_config.Channel[0].Bitmap.dwHeight * 4];
	if (g_config.Channel[0].Bitmap.pRGB)
	{
		JVS_GetBitmap(0, g_config.Channel[0].Bitmap.pRGB);
	}
	
}

LRESULT CJVSDKDEMODlg::OnSDKNotify(WPARAM wParam, LPARAM lParam)
{
	if (lParam == JVS_WM_COPYRIGHT)
	{
		//Ӧͨͨ˰Ȩ֤ԶȡͨĳڡкšGUIDŵ
	}
	else if (lParam == JVS_WM_BITMAP_OK)		//SDKץͼ֪ͨ
	{
		int nChannel = wParam;
		if (nChannel<0 || nChannel > JDVR_MAX_CHANNEL)
		{
			return FALSE;
		}
		if (g_config.Channel[nChannel].Bitmap.pRGB == NULL)
		{
			return FALSE;
		}
		int nWidth = g_config.Channel[0].Bitmap.dwWidth;
		int nHeight = g_config.Channel[0].Bitmap.dwHeight;
		int nBits = 4;
		ULONG ulSize = nWidth * nHeight * nBits;
		FILE * fout = fopen("bitmap.bmp", "wb");
		if (fout)
		{
			BITMAPFILEHEADER bmHeader;
			memset(&bmHeader, 0, sizeof(bmHeader));
			bmHeader.bfType = 0x4D42;
			bmHeader.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + nWidth * nHeight * nBits;
			bmHeader.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

			BITMAPINFOHEADER bmInfo;
			memset(&bmInfo, 0, sizeof(bmInfo));
			bmInfo.biSize = sizeof(bmInfo);
			bmInfo.biWidth	=	nWidth;
			bmInfo.biHeight	=	nHeight;
			bmInfo.biPlanes	=	1;
			bmInfo.biBitCount	=	nBits * 8;
			bmInfo.biCompression	=	0;
			bmInfo.biSizeImage	=	nWidth * nHeight * nBits;
			bmInfo.biXPelsPerMeter	=	300;
			bmInfo.biYPelsPerMeter	=	300;

			fwrite(&bmHeader, sizeof(bmHeader), 1, fout);
			fwrite(&bmInfo, sizeof(bmInfo), 1, fout);
			fwrite(g_config.Channel[nChannel].Bitmap.pRGB, nWidth * nHeight * nBits, 1, fout);

			fclose(fout);
			m_lstInfo.SetCurSel(m_lstInfo.AddString("Capture to \"bitmap.bmp\""));
			//ͷRGB
			delete[] g_config.Channel[nChannel].Bitmap.pRGB;
			g_config.Channel[nChannel].Bitmap.pRGB = NULL;
		}
	}
	return TRUE;
}

void CJVSDKDEMODlg::OnButtonNetwork() 
{
	// TODO: Add your control notification handler code here
	if (m_pSocket)
	{
		m_lstInfo.AddString("Network Services is already open");
		return;
	}

	//
	CJvsSock * pSocket = new CJvsSock;
	if (pSocket->Create(9100, SOCK_DGRAM))
	{
		int nSize = 512 * 1024;
		pSocket->SetSockOpt(SO_SNDBUF, &nSize, sizeof(int));
		m_pSocket = pSocket;
		pSocket->m_nChannel = 0;
		pSocket->m_hParent = this;
		g_config.Channel[0].hSocket = pSocket;
		m_lstInfo.AddString("Start network transmission service successfully!");
	}
	else
	{
		delete pSocket;
		m_lstInfo.AddString("Failed to create network transmission services!" );
	}
	
}

void CJVSDKDEMODlg::OnCheckMovDetect() 
{
	// TODO: Add your control notification handler code here
	if (((CButton *)GetDlgItem(IDC_CHECK_MOV_DETECT))->GetCheck())
	{
		JVS_SetMovDetect(0, GetDlgItemInt(IDC_EDIT_MOV_GRADE), GetDlgItemInt(IDC_EDIT_MOV_THRESHOLD), 24, 0, NULL);
	}
	else
	{
		//nSceneCut=0ʱرƶ
		JVS_SetMovDetect(0, 0, 0, 0, 0, NULL);
	}
	//ƶúѹʹµЧ
}

void CJVSDKDEMODlg::OnCheckAudioPreview() 
{
	// TODO: Add your control notification handler code here
	if (((CButton *)GetDlgItem(IDC_CHECK_AUDIO_PREVIEW))->GetCheck())
	{
		JVS_SetAudioPreview(0, this->GetSafeHwnd(), TRUE);
	}
	else
	{
		JVS_SetAudioPreview(0, NULL, FALSE);
	}
	
}

void CJVSDKDEMODlg::OnCheckAudioCompress() 
{
	// TODO: Add your control notification handler code here
	//ULONG ul = JVS_GetVolume(0);
	JVS_SetAudioCompress(0, ((CButton *)GetDlgItem(IDC_CHECK_AUDIO_COMPRESS))->GetCheck());
	JVS_SetAudioCompressNet(0, FALSE);
}

void CJVSDKDEMODlg::OnButtonSetMode() 
{
	// TODO: Add your control notification handler code here
	DWORD dwPixeMode = m_comboMode.GetCurSel();

	JVS_SetVideoPixelMode(0, dwPixeMode, ((CButton *)GetDlgItem(IDC_CHECK_NTSC))->GetCheck(),m_chkWD1MODE.GetCheck());
}


void CJVSDKDEMODlg::OnButtonCapFile() 
{
	// TODO: Add your control notification handler code here
	if (g_config.Channel[0].bOpened == FALSE)
		return;

	JVS_GetBitmapToFile(0, (PUCHAR)"bitmap2.bmp");
	
}

void CJVSDKDEMODlg::OnButtonRawData() 
{
	// TODO: Add your control notification handler code here
	//עص
	JVS_SetCallBack(FuncEncDataCallback,FuncEncDataCallbacknet,FuncRawDataCallback);
	
}

//SDKڲõĴԭʼݵĻصǰͨJVS_GetBitmapSize()õƵĿ
//ע⣺ԭʼݵĴƵԤѹҪJVS_StartCapture()
void FuncRawDataCallback(int nChannel, PUCHAR pRawBuffer, DWORD dwVideo,DWORD dwHD1)
{
	Beep(1000, 1);
}

LRESULT CJVSDKDEMODlg::OnDeviceChange(WPARAM wParam, LPARAM lParam)
{
	switch(JVS_USBDeviceMessage(wParam, lParam))
	{
	case JVS_DEVICE_LOST:
		{
			UpdateDevices();
		}
		break;
	case JVS_DEVICE_FIND:
		{
			UpdateDevices();
		}
		break;
	}
	
	return S_OK;
}

void CJVSDKDEMODlg::UpdateDevices()
{
	JVS_GetChipType(0, &g_config.dwDeviceType, &g_config.dwChipType);
	
	BOOL bHasCard = FALSE;
	BOOL bUnknowCard = FALSE;
	CString strCardType;
	switch(g_config.dwDeviceType)
	{
	case USBDT_C300:
		strCardType = "JVS-C300Q";
	case USBDT_C301:
		strCardType = "JVS-C301";
		bHasCard = TRUE;
		bUnknowCard = FALSE;
		break;
		
	case USBDT_Unknown:
		bHasCard = FALSE;
		bUnknowCard = FALSE;
		break;
		
	default:
		bHasCard = TRUE;
		bUnknowCard = TRUE;
		break;
	}
	if(!bHasCard)
	{
		m_lstInfo.AddString("No Device");
	}
	else if(bUnknowCard)
	{
		m_lstInfo.AddString("Unsupported device");
	}
	else
	{
		CString s;
		s.Format("Found %s USB Card", strCardType);
		//s.Format("ͨ%dΪʾĿǰֻʹ1·", g_config.nTotalChannel);
		m_lstInfo.AddString(s);
	}
}
